<template lang="pug">
    div
        photo-input(
            v-if="loaded"
            :show="showPhotoInput"
            @hide="showPhotoInput = false"
        )
        div.d-flex
            v-btn.mx-auto(
                color="success"
                @click="$router.push({name: 'gis', params: {projectid, siteid, trenchid}})"
            ) Trench Map
            v-btn.mx-auto(
                color="success"
                @click="$router.push({name: 'matrix', params: {projectid, siteid, trenchid}})"
            ) Harris Matrix
        context-card(
            :headers="headers"
            :context="coffins"
            context-type="Coffins"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="cuts"
            context-type="Cuts"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="deposits"
            context-type="Deposits"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="masonry"
            context-type="Masonry"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="skeletons"
            context-type="Skeletons"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="timbers"
            context-type="Timbers"
            @view-context="viewContext"
            @new-context="newContext"
        )
        context-card(
            :headers="headers"
            :context="photos"
            context-type="Photos"
            @view-context="viewPhoto"
            @new-context="newPhoto"
        )
        v-speed-dial.text-right(
            v-model="speedDial"
            transition="slide-x-reverse-transition"
            bottom
            right
            fixed
        )
            template(v-slot:activator)
                v-btn#newTrenchButton(
                    v-model="speedDial"
                    color="success"
                    fab
                    large
                )
                    v-icon mdi-plus-circle-outline
            div.text-right.mr-12
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('coffin')"
                )
                    v-icon(left) mdi-coffin
                    | Coffin
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('cut')"
                )
                    v-icon(left) mdi-content-cut
                    | Cut
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('deposit')"
                )
                    v-icon(left) mdi-format-color-fill
                    | Deposit
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('masonry')"
                )
                    v-icon(left) mdi-wall
                    | Masonry
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('skeleton')"
                )
                    v-icon(left) mdi-bone
                    | Skeleton
                v-btn(
                    rounded
                    dark
                    small
                    color="indigo"
                    @click="newContext('timber')"
                )
                    v-icon(left) mdi-tree
                    | Timber
        v-dialog(
            v-model="showPDF"
            transition="dialog-bottom-transition"
            fullscreen
        )
            v-card
                v-toolbar
                    v-btn(@click="showPDF = false") Close
                coffin(
                    v-if="viewType === 'Coffins'"
                )
                cut(
                    v-if="viewType === 'Cuts'"
                )
                deposit(
                    v-if="viewType === 'Deposits'"
                )
                masonry(
                    v-if="viewType === 'Masonry'"
                )
                skeleton(
                    v-if="viewType === 'Skeletons'"
                )
                timber(
                    v-if="viewType === 'Timbers'"
                )
                img(v-if="image" :src="pdf")
</template>

<script>
import { mapGetters, mapActions } from "vuex";

import axiosFactory from "@/../helpers/customAxios";

const axios = axiosFactory();

export default {
    name: "trench-options",
    components: {
        Coffin: () => import("../components/ContextView/Coffin"),
        Cut: () => import("../components/ContextView/Cut"),
        Deposit: () => import("../components/ContextView/Deposit"),
        Masonry: () => import("../components/ContextView/Masonry"),
        Skeleton: () => import("../components/ContextView/Skeleton"),
        Timber: () => import("../components/ContextView/Timber"),
        ContextCard: () => import("../components/Context_Card"),
        PhotoInput: () => import("../components/Photo_New")
    },
    props: {
        projectid: {
            required: true,
            type: String
        },
        siteid: {
            required: true,
            type: String
        },
        trenchid: {
            required: true,
            type: String
        }
    },
    data() {
        return {
            showPhotoInput: false,
            snackbar: false,
            notification: "",
            headers: [{ text: "Context Number", value: "attributes.number" }],
            speedDial: false,
            showEditModal: false,
            viewType: "",
            pdf: null,
            showPDF: false,
            image: false,
            gis: null,
            gisUpdate: 0,
            loaded: false
        };
    },
    mounted() {
        this.fetchData();
    },
    computed: {
        allUsers() {
            return this.$store.state.allUsers;
        },
        ...mapGetters({
            currentTrench: "trench/getATrench",
            coffins: "coffin/getAllCoffin",
            getACoffin: "coffin/getACoffin",
            cuts: "cut/getAllCut",
            deposits: "deposit/getAllDeposit",
            masonry: "masonry/getAllMasonry",
            skeletons: "skeleton/getAllSkeleton",
            timbers: "timber/getAllTimber",
            photos: "photo/getAllPhoto",
            allUsers: "users/getAllUser"
        })
    },
    methods: {
        ...mapActions({
            fetchACoffin: "coffin/fetchACoffin",
            fetchACut: "cut/fetchACut",
            fetchADeposit: "deposit/fetchADeposit",
            fetchAMasonry: "masonry/fetchAMasonry",
            fetchASkeleton: "skeleton/fetchASkeleton",
            fetchATimber: "timber/fetchATimber"
        }),
        fetchData() {
            this.$store
                .dispatch("getCurrentURL", {
                    projectID: this.projectid,
                    siteID: this.siteid,
                    trenchID: this.trenchid
                })
                .then(() => {
                    this.loaded = true;
                });
        },
        newContext(contextType) {
            contextType =
                contextType.slice(0, 1).toLowerCase() + contextType.slice(1);
            contextType =
                contextType.slice(-1) === "s"
                    ? contextType.slice(0, -1)
                    : contextType;
            this.$router.push({
                path: `contexts/${contextType}/new`
            });
        },
        viewContext({ type, selected }) {
            this.viewType = type;
            let fetch;
            if (type === "Coffins") {
                fetch = this.fetchACoffin({
                    link: selected[0].relationships.context_detail
                });
            } else if (type === "Cuts") {
                fetch = this.fetchACut({
                    link: selected[0].relationships.context_detail
                });
            } else if (type === "Deposits") {
                fetch = this.fetchADeposit({
                    link: selected[0].relationships.context_detail
                });
            } else if (type === "Masonry") {
                fetch = this.fetchAMasonry({
                    link: selected[0].relationships.context_detail
                });
            } else if (type === "Skeletons") {
                fetch = this.fetchASkeleton({
                    link: selected[0].relationships.context_detail
                });
            } else if (type === "Timbers") {
                fetch = this.fetchATimber({
                    link: selected[0].relationships.context_detail
                });
            }
            fetch.then(response => {
                this.showPDF = true;
            });
        },
        newPhoto() {
            this.showPhotoInput = true;
        },
        viewPhoto({ type, selected }) {
            axios.get(selected[0].links.download).then(response => {
                this.pdf = response.data;
                this.image = true;
                this.showPDF = true;
            });
        }
    }
};
</script>
